/*
 * Copyright (C) 2001-2002 by jerryhj.
 */
#pragma ident "@(#)$Id: gsupk.c,v 0.0.0.1 2002/05/24 $"

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

const unsigned char *gsuhead = "unsigned char gsu[] = {";
const unsigned char *gsuhead_v9 = "unsigned char gsu_v9[] = {";
const unsigned char *tail = "\n\t0x0\n};\n";
const unsigned char *gsustr = "#define GSULEN 0x";
const unsigned char *gsustr_v9 = "#define GSULEN_V9 0x";

int main()
{
	FILE *p;
	fpos_t pos;
	struct stat st;
	int cnt_gsu, cnt_gsu_v9, i;
	unsigned char *buf, *str1;
	unsigned char str[16];

	
	if(stat("gsu", &st) == -1) {
		printf("stat gsu error![errno = %d]\n", errno);
		goto err;
	}
	cnt_gsu = st.st_size;
	if((buf = (char *)malloc(cnt_gsu)) == NULL) {
		printf("malloc for gsu error![errno = %d]\n", errno);
		goto err;
	}
	
	if((p = fopen("gsu", "r")) == 0) {
		printf("create gsu error![errno = %d]\n", errno);
		goto freebuf;
	}
	if(fread(buf, cnt_gsu, 1, p) == 0) {
		printf("read from to gsu error![errno = %d]\n", errno);
		goto close;
	}
	fclose(p);
	
	if((p = fopen("gsu_ar.c", "w")) == 0) {
		printf("create gsu_ar.c error![errno = %d]\n", errno);
		goto freebuf;
	}
	if(fwrite(gsuhead, strlen(gsuhead), 1, p) == 0) {
		printf("write head to gsu_ar.c error![errno = %d]\n", errno);
		goto close;
	}
	for(i = 0; i < cnt_gsu; i++) {
		if(i%10 == 0)
			sprintf(str, "\n\t0x%x,\t", buf[i]);
		else
			sprintf(str, "0x%x,\t", buf[i]);
		if(fwrite(str, strlen(str), 1, p) == 0) {
			printf("write to gsu_ar.c 1 error![errno = %d]\n", errno);
			goto close;
		}
	}
	if(fwrite(tail, strlen(tail), 1, p) == 0) {
		printf("write tail to gsu_ar.c 1 error![errno = %d]\n", errno);
		goto close;
	}
	free(buf);
	fclose(p);


	if(stat("gsu_v9", &st) == -1) {
		printf("stat gsu_v9 error![errno = %d]\n", errno);
		goto err;
	}
	cnt_gsu_v9 = st.st_size;
	if((buf = (char *)malloc(cnt_gsu_v9)) == NULL) {
		printf("malloc for gsu_v9 error![errno = %d]\n", errno);
		goto err;
	}
	
	if((p = fopen("gsu_v9", "r")) == 0) {
		printf("create gsu_v9 error![errno = %d]\n", errno);
		goto freebuf;
	}
	if(fread(buf, cnt_gsu_v9, 1, p) == 0) {
		printf("read from to gsu_v9 error![errno = %d]\n", errno);
		goto close;
	}
	fclose(p);
	
	if((p = fopen("gsu_v9_ar.c", "w")) == 0) {
		printf("create gsu_v9_ar.c error![errno = %d]\n", errno);
		goto freebuf;
	}
	if(fwrite(gsuhead_v9, strlen(gsuhead_v9), 1, p) == 0) {
		printf("write head to gsu_v9_ar.c error![errno = %d]\n", errno);
		goto close;
	}
	for(i = 0; i < cnt_gsu_v9; i++) {
		if(i%10 == 0)
			sprintf(str, "\n\t0x%x,\t", buf[i]);
		else
			sprintf(str, "0x%x,\t", buf[i]);
		if(fwrite(str, strlen(str), 1, p) == 0) {
			printf("write to gsu_v9_ar.c 1 error![errno = %d]\n", errno);
			goto close;
		}
	}
	if(fwrite(tail, strlen(tail), 1, p) == 0) {
		printf("write tail to gsu_v9_ar.c 1 error![errno = %d]\n", errno);
		goto close;
	}
	free(buf);
	fclose(p);


	if(stat("rgsu.c", &st) == -1) {
		printf("stat rgsu.c error![errno = %d]\n", errno);
		goto err;
	}
	if((buf = (char *)malloc(st.st_size)) == NULL) {
		printf("malloc for rgsu.c error![errno = %d]\n", errno);
		goto err;
	}
	
	if((p = fopen("rgsu.c", "r+")) == 0) {
		printf("create rgsu.c error![errno = %d]\n", errno);
		goto freebuf;
	}
	if(fread(buf, st.st_size, 1, p) == 0) {
		printf("read from to rgsu.c error![errno = %d]\n", errno);
		goto close;
	}
	
	sprintf(str, "%x", cnt_gsu);
	if((str1 = strstr(buf, gsustr)) == NULL) {
		printf("strstr for gsustr in rgsu.c error![buf = %s]\n", buf);
		goto close;
	}
	str1 += strlen(gsustr) + 8 - strlen(str);
	memcpy(str1, str, strlen(str));

	sprintf(str,"%x", cnt_gsu_v9);
	if((str1 = strstr(buf, gsustr_v9)) == NULL) {
		printf("strstr for gsustr_v9 in rgsu.c error![buf = %s]\n", buf);
		goto close;
	}
	str1 += strlen(gsustr_v9) + 8 - strlen(str);
	memcpy(str1, str, strlen(str));
	
	rewind(p);
	if(fwrite(buf, st.st_size, 1, p) == 0) {
		printf("write to rgsu.c error![errno = %d]\n", errno);
		goto close;
	}
	free(buf);
	fclose(p);
	
	return 0;
close:;
	fclose(p);
freebuf:;
	free(buf);
err:;
	return -1;
}
